diff --git a/kdeui/itemviews/kcategorizedview.cpp b/kdeui/itemviews/kcategorizedview.cpp
index 4b30859..005102a 100644
--- a/kdeui/itemviews/kcategorizedview.cpp
+++ b/kdeui/itemviews/kcategorizedview.cpp
@@ -1482,26 +1107,7 @@ void KCategorizedView::rowsInserted(const QModelIndex &parent,
                                     int end)
 {
     QListView::rowsInserted(parent, start, end);
-
-    if (!d->proxyModel || !d->categoryDrawer || !d->proxyModel->isCategorizedModel())
-    {
-        d->forcedSelectionPosition = 0;
-        d->elementsInfo.clear();
-        d->elementsPosition.clear();
-        d->categoriesIndexes.clear();
-        d->categoriesPosition.clear();
-        d->categories.clear();
-        d->intersectedIndexes.clear();
-        d->modelIndexList.clear();
-        d->hovered = QModelIndex();
-        d->biggestItemSize = QSize(0, 0);
-        d->mouseButtonPressed = false;
-        d->rightMouseButtonPressed = false;
-
-        return;
-    }
-
-    rowsInsertedArtifficial(parent, start, end);
+    d->rowsInserted(parent, start, end);
 }
 
 void KCategorizedView::rowsInsertedArtifficial(const QModelIndex &parent,
@@ -1509,75 +1115,8 @@ void KCategorizedView::rowsInsertedArtifficial(const QModelIndex &parent,
                                                int end)
 {
     Q_UNUSED(parent);
-
-    d->forcedSelectionPosition = 0;
-    d->elementsInfo.clear();
-    d->elementsPosition.clear();
-    d->categoriesIndexes.clear();
-    d->categoriesPosition.clear();
-    d->categories.clear();
-    d->intersectedIndexes.clear();
-    d->modelIndexList.clear();
-    d->hovered = QModelIndex();
-    d->biggestItemSize = QSize(0, 0);
-    d->mouseButtonPressed = false;
-    d->rightMouseButtonPressed = false;
-
-    if (start > end || end < 0 || start < 0 || !d->proxyModel->rowCount())
-    {
-        return;
-    }
-
-    // Add all elements mapped to the source model and explore categories
-    QString prevCategory = d->proxyModel->data(d->proxyModel->index(0, d->proxyModel->sortColumn()), KCategorizedSortFilterProxyModel::CategoryDisplayRole).toString();
-    QString lastCategory = prevCategory;
-    QModelIndexList modelIndexList;
-    struct Private::ElementInfo elementInfo;
-    int offset = -1;
-    for (int k = 0; k < d->proxyModel->rowCount(); ++k)
-    {
-        QModelIndex index = d->proxyModel->index(k, d->proxyModel->sortColumn());
-        QModelIndex indexSize = d->proxyModel->index(k, 0);
-
-        d->biggestItemSize = QSize(qMax(sizeHintForIndex(indexSize).width(),
-                                        d->biggestItemSize.width()),
-                                   qMax(sizeHintForIndex(indexSize).height(),
-                                        d->biggestItemSize.height()));
-
-        d->modelIndexList << index;
-
-        lastCategory = d->proxyModel->data(index, KCategorizedSortFilterProxyModel::CategoryDisplayRole).toString();
-
-        elementInfo.category = lastCategory;
-
-        if (prevCategory != lastCategory)
-        {
-            offset = 0;
-            d->categoriesIndexes.insert(prevCategory, modelIndexList);
-            d->categories << prevCategory;
-            modelIndexList.clear();
-        }
-        else
-        {
-            offset++;
-        }
-
-        elementInfo.relativeOffsetToCategory = offset;
-
-        modelIndexList << index;
-        prevCategory = lastCategory;
-
-        d->elementsInfo.insert(index.row(), elementInfo);
-    }
-
-    d->categoriesIndexes.insert(prevCategory, modelIndexList);
-    d->categories << prevCategory;
-
-    d->updateScrollbars();
-
-    // FIXME: We need to safely save the last selection. This is on my TODO
-    // list (ereslibre).
-    selectionModel()->clear();
+    Q_UNUSED(start);
+    Q_UNUSED(end);
 }
 
 void KCategorizedView::rowsRemoved(const QModelIndex &parent,
@@ -1587,91 +1126,16 @@ void KCategorizedView::rowsRemoved(const QModelIndex &parent,
     Q_UNUSED(parent);
     Q_UNUSED(start);
     Q_UNUSED(end);
-    if (d->proxyModel && d->categoryDrawer && d->proxyModel->isCategorizedModel())
-    {
-        // Force the view to update all elements
-        rowsInsertedArtifficial(QModelIndex(), 0, d->proxyModel->rowCount() - 1);
-    }
-}
-
-void KCategorizedView::updateGeometries()
-{
-    if (!d->proxyModel || !d->categoryDrawer || !d->proxyModel->isCategorizedModel())
-    {
-        QListView::updateGeometries();
-        return;
-    }
-
-    // Avoid QListView::updateGeometries(), since it will try to set another
-    // range to our scroll bars, what we don't want (ereslibre)
-    QAbstractItemView::updateGeometries();
 }
 
 void KCategorizedView::slotLayoutChanged()
 {
-    d->layoutChanged();
-}
-
-void KCategorizedView::currentChanged(const QModelIndex &current,
-                                      const QModelIndex &previous)
-{
-    // We need to update the forcedSelectionPosition property in order to correctly
-    // navigate after with keyboard using up & down keys
-
-    int viewportWidth = viewport()->width() - spacing();
-
-    int itemHeight;
-    int itemWidth;
-
-    if (gridSize().isEmpty())
-    {
-        itemHeight = d->biggestItemSize.height();
-        itemWidth = d->biggestItemSize.width();
-    }
-    else
-    {
-        itemHeight = gridSize().height();
-        itemWidth = gridSize().width();
+    d->blocks.clear();
+    if (d->proxyModel->rowCount()) {
+        d->rowsInserted(rootIndex(), 0, d->proxyModel->rowCount() - 1);
     }
-
-    int itemWidthPlusSeparation = spacing() + itemWidth;
-    if (!itemWidthPlusSeparation)
-        itemWidthPlusSeparation++;
-    int elementsPerRow = viewportWidth / itemWidthPlusSeparation;
-    if (!elementsPerRow)
-        elementsPerRow++;
-
-    if (d->mouseButtonPressed || d->rightMouseButtonPressed)
-        d->forcedSelectionPosition = d->elementsInfo[current.row()].relativeOffsetToCategory % elementsPerRow;
-
-    QListView::currentChanged(current, previous);
 }
 
-void KCategorizedView::dataChanged(const QModelIndex &topLeft,
-                                   const QModelIndex &bottomRight)
-{
-    if (topLeft == bottomRight)
-    {
-        d->cacheIndex(topLeft);
-    }
-    else
-    {
-        const int columnStart = topLeft.column();
-        const int columnEnd = bottomRight.column();
-        const int rowStart = topLeft.row();
-        const int rowEnd = bottomRight.row();
-
-        for (int row = rowStart; row <= rowEnd; ++row)
-        {
-            for (int column = columnStart; column <= columnEnd; ++column)
-            {
-                d->cacheIndex(d->proxyModel->index(row, column));
-            }
-        }
-    }
-
-    QListView::dataChanged(topLeft, bottomRight);
-    slotLayoutChanged();
-}
+//END: Public part
 
 #include "kcategorizedview.moc"
diff --git a/kdeui/itemviews/kcategorizedview.h b/kdeui/itemviews/kcategorizedview.h
index 9352a15..caba845 100644
--- a/kdeui/itemviews/kcategorizedview.h
+++ b/kdeui/itemviews/kcategorizedview.h
@@ -1,6 +1,6 @@
 /**
   * This file is part of the KDE project
-  * Copyright (C) 2007 Rafael Fernández López <ereslibre@kde.org>
+  * Copyright (C) 2007, 2008 Rafael Fernández López <ereslibre@kde.org>
   *
   * This library is free software; you can redistribute it and/or
   * modify it under the terms of the GNU Library General Public
@@ -26,6 +26,7 @@
 #include <kdeui_export.h>
 
 class KCategoryDrawer;
+class KCategoryDrawerV2;
 
 /**
   * @short Item view for listing items
@@ -57,9 +58,38 @@ public:
 
     void setCategoryDrawer(KCategoryDrawer *categoryDrawer);
 
+    /**
+      * @since 4.3
+      */
+    int categorySpacing() const;
+
+    /**
+      * @since 4.3
+      */
+    void setCategorySpacing(int categorySpacing);
+
+    /**
+      * @since 4.3
+      */
+    bool alternatingBlockColors() const;
+
+    /**
+      * @since 4.3
+      */
+    void setAlternatingBlockColors(bool enable);
+
+    /**
+      * @since 4.3
+      */
+    bool collapsibleBlocks() const;
+
+    /**
+      * @since 4.3
+      */
+    void setCollapsibleBlocks(bool enable);
+
     virtual QModelIndex indexAt(const QPoint &point) const;
 
-public Q_SLOTS:
     virtual void reset();
 
 protected:
@@ -89,11 +119,23 @@ protected:
     virtual QModelIndex moveCursor(CursorAction cursorAction,
                                    Qt::KeyboardModifiers modifiers);
 
-protected Q_SLOTS:
+    virtual void rowsAboutToBeRemoved(const QModelIndex &parent,
+                                      int start,
+                                      int end);
+
+    virtual void updateGeometries();
+
+    virtual void currentChanged(const QModelIndex &current,
+                                const QModelIndex &previous);
+
+    virtual void dataChanged(const QModelIndex &topLeft,
+                             const QModelIndex &bottomRight);
+
     virtual void rowsInserted(const QModelIndex &parent,
                               int start,
                               int end);
 
+protected Q_SLOTS:
     virtual void rowsInsertedArtifficial(const QModelIndex &parent,
                                          int start,
                                          int end);
@@ -102,19 +144,13 @@ protected Q_SLOTS:
                              int start,
                              int end);
 
-    virtual void updateGeometries();
-
     virtual void slotLayoutChanged();
 
-    virtual void currentChanged(const QModelIndex &current,
-                                const QModelIndex &previous);
-
-    virtual void dataChanged(const QModelIndex &topLeft,
-                             const QModelIndex &bottomRight);
-
 private:
     class Private;
     Private *const d;
+
+    Q_PRIVATE_SLOT(d, void _k_slotCollapseOrExpandClicked())
 };
 
 #endif // KCATEGORIZEDVIEW_H
diff --git a/kdeui/itemviews/kcategorizedview_p.h b/kdeui/itemviews/kcategorizedview_p.h
index a18854b..9e7210f 100644
--- a/kdeui/itemviews/kcategorizedview_p.h
+++ b/kdeui/itemviews/kcategorizedview_p.h
@@ -1,6 +1,6 @@
 /**
   * This file is part of the KDE project
-  * Copyright (C) 2007 Rafael Fernández López <ereslibre@kde.org>
+  * Copyright (C) 2007, 2008 Rafael Fernández López <ereslibre@kde.org>
   *
   * This library is free software; you can redistribute it and/or
   * modify it under the terms of the GNU Library General Public
@@ -30,135 +30,98 @@ class KCategoryDrawer;
 class KCategorizedView::Private
 {
 public:
-    Private(KCategorizedView *listView);
-    ~Private();
-
+    struct Block;
+    struct Item;
 
-    // Methods
-
-    /**
-      * Returns the list of items that intersects with @p rect
-      */
-    const QModelIndexList &intersectionSet(const QRect &rect);
+    Private(KCategorizedView *q);
+    ~Private();
 
-    /**
-      * Gets the item rect in the viewport for @p index
-      */
-    QRect visualRectInViewport(const QModelIndex &index) const;
+    bool isCategorized() const;
 
     /**
-      * Returns the category rect in the viewport for @p category
+      * Returns the first and last element that intersects with rect.
+      *
+      * @note see that here we cannot take out items between first and last (as we could
+      *       do with the rubberband).
+      *
+      * Complexity: O(log(n)) where n is model()->rowCount().
       */
-    QRect visualCategoryRectInViewport(const QString &category) const;
+    QPair<QModelIndex, QModelIndex> intersectingIndexesWithRect(const QRect &rect) const;
 
     /**
-      * Caches and returns the rect that corresponds to @p index
+      * Returns the position of the block of @p category.
+      *
+      * Complexity: O(n) where n is the number of different categories when the block has been
+      *             marked as in quarantine. O(1) the rest of the times (the vast majority).
       */
-    const QRect &cacheIndex(const QModelIndex &index);
+    QPoint blockPosition(const QString &category);
 
     /**
-      * Caches and returns the rect that corresponds to @p category
+      * Returns the height of the block determined by @p category.
       */
-    const QRect &cacheCategory(const QString &category);
+    int blockHeight(const QString &category);
 
     /**
-      * Returns the rect that corresponds to @p index
-      * @note If the rect is not cached, it becomes cached
+      * Returns the actual viewport width.
       */
-    const QRect &cachedRectIndex(const QModelIndex &index);
+    int viewportWidth() const;
 
     /**
-      * Returns the rect that corresponds to @p category
-      * @note If the rect is not cached, it becomes cached
+      * Marks all elements as in quarantine.
+      *
+      * Complexity: O(n) where n is model()->rowCount().
+      *
+      * @warning this is an expensive operation
       */
-    const QRect &cachedRectCategory(const QString &category);
+    void regenerateAllElements();
 
     /**
-      * Returns the visual rect (taking in count x and y offsets) for @p index
-      * @note If the rect is not cached, it becomes cached
+      * Update internal information, and keep sync with the real information that the model contains.
       */
-    QRect visualRect(const QModelIndex &index);
+    void rowsInserted(const QModelIndex &parent, int start, int end);
 
     /**
-      * Returns the visual rect (taking in count x and y offsets) for @p category
-      * @note If the rect is not cached, it becomes cached
+      * Returns @p rect in viewport terms, taking in count horizontal and vertical offsets.
       */
-    QRect categoryVisualRect(const QString &category);
+    QRect mapToViewport(const QRect &rect) const;
 
     /**
-      * This method will draw a new category represented by index
-      * @param index  on the rect specified by @p option.rect, with
-      * painter @p painter
+      * Returns @p rect in absolute terms, converted from viewport position.
       */
-    void drawNewCategory(const QModelIndex &index,
-                         int sortRole,
-                         const QStyleOption &option,
-                         QPainter *painter);
+    QRect mapFromViewport(const QRect &rect) const;
 
     /**
-      * This method will update scrollbars ranges. Called when our model changes
-      * or when the view is resized
+      * Returns the height of the highest element in last row. This is only applicable if there is
+      * no grid set and uniformItemSizes is false.
+      *
+      * @param block in which block are we searching. Necessary to stop the search if we hit the
+      *              first item in this block.
       */
-    void updateScrollbars();
+    int highestElementInLastRow(const Block &block) const;
 
     /**
-      * This method will draw dragged items in the painting operation
+      * Returns whether the view has a valid grid size.
       */
-    void drawDraggedItems(QPainter *painter);
+    bool hasGrid() const;
 
-    /**
-      * This method will determine which rect needs to be updated because of a
-      * dragging operation
-      */
-    void drawDraggedItems();
+    QString categoryForIndex(const QModelIndex &index) const;
 
-    void layoutChanged(bool forceItemReload = false);
+    void _k_slotCollapseOrExpandClicked();
 
+    KCategorizedView *q;
+    KCategorizedSortFilterProxyModel *proxyModel;
+    KCategoryDrawer *categoryDrawer;
+    KCategoryDrawerV2 *categoryDrawerV2;
+    int categorySpacing;
+    bool alternatingBlockColors;
+    bool collapsibleBlocks;
 
-    // Attributes
+    QModelIndex hoveredIndex;
 
-    struct ElementInfo
-    {
-        QString category;
-        int relativeOffsetToCategory;
-    };
+    QPoint pressedPosition;
+    QRect rubberBandRect;
 
-    // Basic data
-    KCategorizedView *listView;
-    KCategoryDrawer *categoryDrawer;
-    QSize biggestItemSize;
-
-    // Behavior data
-    bool mouseButtonPressed;
-    bool rightMouseButtonPressed;
-    bool isDragging;
-    bool dragLeftViewport;
-    QModelIndex hovered;
-    QString hoveredCategory;
-    QPoint initialPressPosition;
-    QPoint mousePosition;
-    int forcedSelectionPosition;
-
-    // Cache data
-    // We cannot merge some of them into structs because it would affect
-    // performance
-    QHash<int, struct ElementInfo> elementsInfo;
-    QHash<int, QRect> elementsPosition;
-    QHash<QString, QModelIndexList> categoriesIndexes;
-    QHash<QString, QRect> categoriesPosition;
-    QStringList categories;
-    QModelIndexList intersectedIndexes;
-    QRect lastDraggedItemsRect;
-    int modelSortRole;
-    int modelSortColumn;
-    int modelLastRowCount;
-    bool modelCategorized;
-    Qt::SortOrder modelSortOrder;
-    QItemSelection lastSelection;
-
-    // Attributes for speed reasons
-    KCategorizedSortFilterProxyModel *proxyModel;
-    QModelIndexList modelIndexList;
+    QHash<QString, Block> blocks;
 };
 
 #endif // KCATEGORIZEDVIEW_P_H
diff --git a/kdeui/itemviews/kcategorydrawer.cpp b/kdeui/itemviews/kcategorydrawer.cpp
index c0c10ac..3dbc9e4 100644
--- a/kdeui/itemviews/kcategorydrawer.cpp
+++ b/kdeui/itemviews/kcategorydrawer.cpp
@@ -29,12 +29,31 @@
 
 #define HORIZONTAL_HINT 3
 
+class KCategoryDrawer::Private
+{
+public:
+    Private()
+        : leftMargin(0)
+        , rightMargin(0)
+    {
+    }
+
+    ~Private()
+    {
+    }
+
+    int leftMargin;
+    int rightMargin;
+};
+
 KCategoryDrawer::KCategoryDrawer()
+    : d(new Private)
 {
 }
 
 KCategoryDrawer::~KCategoryDrawer()
 {
+    delete d;
 }
 
 void KCategoryDrawer::drawCategory(const QModelIndex &index,
@@ -102,3 +121,51 @@ int KCategoryDrawer::categoryHeight(const QModelIndex &index, const QStyleOption
 
     return option.fontMetrics.height() + 4 /* 3 separator; 1 gradient */;
 }
+
+int KCategoryDrawer::leftMargin() const
+{
+    return d->leftMargin;
+}
+
+void KCategoryDrawer::setLeftMargin(int leftMargin)
+{
+    d->leftMargin = leftMargin;
+}
+
+int KCategoryDrawer::rightMargin() const
+{
+    return d->rightMargin;
+}
+
+void KCategoryDrawer::setRightMargin(int rightMargin)
+{
+    d->rightMargin = rightMargin;
+}
+
+KCategoryDrawerV2::KCategoryDrawerV2(QObject *parent)
+    : QObject(parent)
+    , KCategoryDrawer()
+{
+}
+
+KCategoryDrawerV2::~KCategoryDrawerV2()
+{
+}
+
+void KCategoryDrawerV2::mouseButtonPressed(const QModelIndex &index, QMouseEvent *event)
+{
+}
+
+void KCategoryDrawerV2::mouseButtonReleased(const QModelIndex &index, QMouseEvent *event)
+{
+}
+
+void KCategoryDrawerV2::mouseButtonMoved(const QModelIndex &index, QMouseEvent *event)
+{
+}
+
+void KCategoryDrawerV2::mouseButtonDoubleClicked(const QModelIndex &index, QMouseEvent *event)
+{
+}
+
+#include "kcategorydrawer.moc"
diff --git a/kdeui/itemviews/kcategorydrawer.h b/kdeui/itemviews/kcategorydrawer.h
index 4e8894d..d4b9941 100644
--- a/kdeui/itemviews/kcategorydrawer.h
+++ b/kdeui/itemviews/kcategorydrawer.h
@@ -23,10 +23,16 @@
 
 #include <kdeui_export.h>
 
+#include <QtCore/QObject>
+#include <QtGui/QMouseEvent>
+
 class QPainter;
 class QModelIndex;
 class QStyleOption;
 
+/**
+  * @warning Please use KCategoryDrawerV2 instead.
+  */
 class KDEUI_EXPORT KCategoryDrawer
 {
 public:
@@ -47,6 +53,58 @@ public:
                               QPainter *painter) const;
 
     virtual int categoryHeight(const QModelIndex &index, const QStyleOption &option) const;
+
+    //TODO KDE5: make virtual as leftMargin
+    /**
+      * @note 0 by default
+      * @since 4.3
+      */
+    int leftMargin() const;
+    /**
+      * @note call to this method on the KCategoryDrawer constructor to set the left margin
+      * @since 4.3
+      */
+    void setLeftMargin(int leftMargin);
+
+    //TODO KDE5: make virtual as rightMargin
+    /**
+      * @note 0 by default
+      * @since 4.3
+      */
+    int rightMargin() const;
+    /**
+      * @note call to this method on the KCategoryDrawer constructor to set the right margin
+      * @since 4.3
+      */
+    void setRightMargin(int rightMargin);
+
+private:
+    class Private;
+    Private *const d;
+};
+
+
+/**
+  * @since 4.3
+  */
+class KDEUI_EXPORT KCategoryDrawerV2
+    : public QObject
+    , public KCategoryDrawer
+{
+    Q_OBJECT
+
+public:
+    KCategoryDrawerV2(QObject *parent = 0);
+
+    virtual ~KCategoryDrawerV2();
+
+    virtual void mouseButtonPressed(const QModelIndex &index, QMouseEvent *event);
+    virtual void mouseButtonReleased(const QModelIndex &index, QMouseEvent *event);
+    virtual void mouseButtonMoved(const QModelIndex &index, QMouseEvent *event);
+    virtual void mouseButtonDoubleClicked(const QModelIndex &index, QMouseEvent *event);
+
+Q_SIGNALS:
+    void collapseOrExpandClicked(const QModelIndex &index);
 };
 
 #endif // KCATEGORYDRAWER_H
